: +LCD : +KEY : +VGA ; ( precede line with \ space to comment and leave out modules )
TACHYON V5

{
v5	dictionary changes, fast search,
V4.7
V4.5 for 4.5 kernel - all DO LOOP styles are now FOR NEXT with optional FROM and BY
	IY is now FOR@
V4.4 for 4.4 kernel - uses DOFOR LOOP
V4r2 for 4.2 kernel - COGREG is removed  - use COG@ and COG! from location 1 onwards
}

IFDEF EXTEND
FORGET EXTEND
--- keyword used to prevent ROMs being wiped on reload of EXTEND
pub ~K ;
}
	vars org

module EXTEND		." Primary extensions to TACHYON V5.2 kernel  - 180322-1300" ;

{
changelog:
180312	Added CREATE DOES>
	Added simple DECOMP
	New STRING word using CREATE DOES>
180219	Fixed PING and improved DHT so that a bad connection does not lock it up.
180218	Added VGA.fth 40x15 VGA text driver as standard
180216	Added CASES for values WITHIN
180108	Removed PRINTNUM and introduced .AS and .AS"
171125	Improved DHT
171024	Trimmed variable usage etc
170915	Fixed timezone and .LAP
170730	Fixed DS3231 temperature reading and improved RTC routines - tested with DS3231 and MCP79410
170725	Hybrid RTC
170712
170612	increased clock width of I2C!? as some EEPROMs failed
"
}




pub PRIVATE 	( -- )		$20 flags SET ;
pub PUBLIC	( -- )		$20 flags CLR ;

\ pub ANYCASE ( on/off -- )	0= 1 flags 1+ ROT BIT! ;



--- lock in CLKFREQ as location 0 can be corrupted easily enough since 0 is returned as false for many operations
PUBLIC
0 @				:= CLKFREQ

CLKFREQ 1,000,000 /		:= CLKMHZ
PRIVATE
-1 2/ CLKFREQ 10,000 / 2/ /	:= HZCON



PRIVATE
long ulong
--- UNALIGNED LONG
pub U!	( long addr --  )	SWAP ulong ! ulong SWAP 4 CMOVE	;
pub U@	( addr -- long )	ulong 4 CMOVE ulong @ ;

--- Fetch big endian
pub BIG@ ( addr -- long )	FROM 0 4 FOR 8<< I C@ + NEXT ;
pub BIG! ( long addr -- )	FROM 4 FOR DUP 24 >> I C! 8<< NEXT DROP ;



--- write a new value to a programmble constant  ( 1234 ' mycon WW! ) simply writes a 15-bit constant to word
pub WW! ( newcon 'oldcon -- )	SWAP $8000 OR SWAP W! ;

--- give the 0-based position of the highest bit set (slow)
pub >| ( mask -- bit )		0 SWAP BEGIN ?DUP WHILE 2/ SWAP 1+ SWAP REPEAT 1- ;

\ pub MASKS ( pin cnt -- mask )		SWAP FROM 0 SWAP FOR I MASK OR NEXT ;

pub LIMIT ( n min max -- n )	ROT MIN MAX ;


pub .W				.WORD SPACE ;
pub .W:				CR .WORD PRINT" : " ;


IFNDEF NUMBER
pub NUMBER ( str -- num )
	DUP C@ SWAP
	0 BEGIN OVER C@ WHILE OVER C@ DUP '0' '9' WITHIN
	  IF '0' - SWAP 10 * + ELSE DROP THEN SWAP 1+ SWAP
	REPEAT NIP SWAP '-' = ?NEGATE
	;
}

\ 16 bytes NUM$
pub NUM>STR ( num -- str )	<# #S #> @WORD 16 CMOVE @WORD ;

--- ON QUIET Non-interactive mode - just accept "commands"
pub QUIET ( on/off -- )		IF OFF ' NOOP ELSE ON 0 THEN prompt W! ECHO ;

--- assign a control key shortcut
pub SHORTCUT ( vec key -- )	2* keytable + W! ;


--- set new cfa to point back to DOES: code (skipped by DOES: itself)
pub DOES>	R> 0 REG W@ W! ;
--- create new dev with dummy cfa (save ptr to it)
pub CREATE	HERE CREATE: GRAB HERE 0 REG W! 0_0 W, ;


--- create an array of bytes in code memory than can be indexed and backed up
pre CARRAY
	CREATE ( cnt -- ) 	FOR 0 C, NEXT
	DOES> ( index -- addr )	R> +
	;
{ usage:
64 CARRAY configs
7 configs C++		--- increment the 8th byte in the array
}

--- long align code memory
pri CALIGN 			HERE 2 AND 0= IF 0 W, THEN ;

--- allocate and fill bytes in code memory
pre cbytes
	CREATE ( val cnt -- ) 	CALIGN 2 ALIGN FOR DUP C, NEXT DROP
	DOES> ( index -- addr ) R> +
	;

--- create a 16-bit word in code memory (saved in EEPROM on BACKUP)
pre cword
	CREATE ( val -- )	W,
	DOES> ( -- addr )	R>
	;
--- create a long in code memory (saved in EEPROM on BACKUP)
pre clong
	CALIGN
	CREATE ( val -- )	L,
	DOES> ( -- addr )	R>
	;

--- Create user register variable (normally up to 256 byte addresses )
pre reg				GRAB >B ' REG W@ + CREATE: ;

pub DS+				@org W+! ;

pre DS
	CREATE ( cnt -- )	@org W@ W, DS+
	DOES> ( -- addr )	R> W@
	;

--- define a wrap constant := val & size-1
pre WRAP
	CREATE ( size -- )	W,
	DOES> ( val -- val2 )	R> W@ 1- AND
	;

pre |<=
	CREATE ( bit -- )	W,
	DOES> ( -- mask )	R> C@ MASK
	;

pre TABLE
	CALIGN
	CREATE ( -- )
	DOES> ( -- addr )	R>
	;

pre STRING	( STRING A$	HELLO WORLD! )
	CREATE ( -- )		BEGIN KEY$ DUP $0D <> WHILE C, REPEAT DROP 0 C,
	DOES> ( -- addr )	R>
	;




--- simple version of CASE -- looking later at use a wordcode instead of "SWITCH@ = IF"

pub SWITCH			uswitch ! ;
pub SWITCH@			uswitch @ ;
pri SWITCH=			SWITCH@ = ;
---				compile SWITCH= IF
pre CASE ( val -- )		' SWITCH= [W,] [C] IF ;
---				compile EXIT THEN
pre BREAK			' EXIT [W,] [C] THEN ;


pri >SWITCH< ( min max -- )	SWITCH@ -ROT WITHIN ;
--- Use as:  from to CASES ..... BREAK
pre CASES			' >SWITCH< [W,] [C] IF ;

{ HELP SWITCHES ( val -- )
Scan the following val and word pairs for a match
or until a non-value is encountered
}
pub SWITCHES ( val -- )
    SWITCH R>
    BEGIN DUP W@ $7FFF >
    WHILE DUP W@ $7FFF AND SWITCH= IF 2+ ?JUMP THEN CELL+
    REPEAT >R
    ;
{ SWITCHES EXAMPLE
SWITCHES $0D LCDCR $0A LCDLF $09 LCDTAB  NOP
This function automatically terminates when it encounters a word in the list
that is not a 15-bit literal, so use any other function including ;
}


--- aliases
ALIAS CASE =[
ALIAS BREAK ]
ALIAS MASK |<

ALIAS ON TRUE
\ ALIAS ON 0-1

PUBLIC
0	:= FALSE
PRIVATE

{
8 longs astk
pub A@		astk @ ;
pub >A		astk DUP CELL+ 28 <CMOVE astk ! ;
pub A>		A@ astk DUP CELL+ SWAP 28 CMOVE ;
}


\ Increment and decrement variables at address
pub ++ ( longAddr -- )				1 SWAP +! ;
pub -- ( longAddr -- )				-1 SWAP +! ;

pub W++ ( wordAddr -- )				1 SWAP W+! ;
pub W-- ( wordAddr -- )				-1 SWAP W+! ;

pub C++ ( byteAddr -- )				1 SWAP C+! ;
pub C-- ( byteAddr -- )				-1 SWAP C+! ;


PUBLIC
--- handy variables
IFNDEF 1!
long @1
pub 1!	( long -- )	@1 ! ;
pub 1@	( -- long )	@1 @ ;
pub 1++			@1 ++ ;
}
long @2
pub 2!			@2 ! ;
pub 2@			@2 @ ;
pub 2++			@2 ++ ;
long @3
pub 3!			@3 ! ;
pub 3@			@3 @ ;
pub 3++			@3 ++ ;

pub >W ( long -- word )				$FFFF AND ;

pub L>W ( long - loword hiword ) 		DUP >W SWAP 8>> 8>> ;
pub W>B ( word - lobyte hibyte ) 		DUP >B SWAP 8>> >B ;

pub B>W	( lobyte hibyte -- word )		8<< OR ;
pub B>L ( lobyte byte2 byte3 byte4 -- long )	B>W 1! B>W 1@
pub W>L ( loword hiword -- long )		8<< 8<< OR ;

--- Clear and set variable at address
\ pub ~   ( longAddr -- )			0 SWAP ! ;
pub ~~  ( longAddr -- )				-1 SWAP ! ;
\ pub W~  ( wordAddr -- )			0 SWAP W! ;
pub W~~ ( wordAddr -- )				-1 SWAP W! ;
\ pub C~  ( byteAddr -- )			0 SWAP C! ;
pub C~~ ( byteAddr -- )				-1 SWAP C! ;


pub AVG ( val var -- avg )
	DUP @ 2/ 2/ ROT SWAP -
	OVER +! @ 2/ 2/
	;





pub <=	( n1 n2 -- flg  )	SWAP
pub =>	( n1 n2 -- flg )	1- > ;

pub @.	( longAddr --  )	@ U. ;
pub D.				<D> U. ;

pub 2SWAP ( n1 n2 n3 n4 -- n3 n4 n1 n2 )	1! ROT ROT 1@ ROT ROT ;
pub 3DUP ( n1 n2 n3 -- n1 n2 n3 n1 n2 n3 )	3RD 3RD 3RD ;
pub 2OVER ( n1 n2 n3 n4 -- n1 n2 n3 n4 n1 n2 )	4TH 4TH ;
pub MOD ( n1 mod -- rem )			U/MOD
pri DROP;					DROP ;

pub INVERT					-1 XOR ;


IFNDEF R@
pub R@						R> R> DUP >R SWAP JUMP ;
}

pub FORK 				R@ >R ;

--- delay for n us ( min 9us)
pub ms 					1000 * 7 -
pub us ( n -- )				8 CMPSUB FOR NOP NEXT ;
pub s ( seconds -- )			FOR CLKFREQ WAITX NEXT ;



1,000,000	:= 1M

pub KB ( kb -- bytes )			10 << ;
pub MB ( mb -- bytes )			20 << ;
pub M ( n -- n*1000000 )		1M * ;
\ pub k ( n -- n*1000 )			1000 * ;


(			CHARACTER I/O REDIRECTION			)


--- Redirect following code as key or emit ---
pub KEY:	R> ukey W! ;
pub EMIT: 	R> uemit W! ;

pub NULLOUT			EMIT: DROP ;

PUBLIC
long boot

PRIVATE
long ~c
--- switch I/O to console but save current device key&emit
pub [CON			uemit @ ~c !
--- reset character I/O ( EMIT & KEY) back to default console
pub CON				uemit ~ ;
--- retyrn from console and restore previous device
pub CON]			~c @ uemit ! ;

\ pub ESC? ( -- flg )		lastkey C@ $1B = ;
pub ESC? ( -- flg )		KEY $1B = ;

PUBLIC
byte NULL$    \ NULL$ C~
PRIVATE




--- Locate the first ch in the string and return else null
pub LOCATE$ ( ch str -- str )
	DUP FROM 0 SWAP LEN$
	  FOR OVER I C@ = IF DROP I LEAVE THEN NEXT
	NIP
	;


pub $= ( str1 str2 -- flg \ Compare two strings for equality )
	OVER LEN$ OVER LEN$ =
	IF
	  DUP FROM LEN$
	  FOR C@++ I C@ <> IF DROP 0 LEAVE THEN NEXT
	  0<>
	ELSE
	  2DROP FALSE
	THEN
	;


--- append str1 at the end of str2
pub APPEND$ ( str1 str2 -- )		DUP LEN$ +
pub $! ( str1 str2 -- )			OVER LEN$ 1+ CMOVE ;

\ ALIAS COPY$ $!

--- add a character to a string
pub +CHAR ( ch str2 -- )		DUP LEN$ + OVER 1+ C~ C! ;
pub MID$ ( str offset len -- str )	-ROT + SWAP
pub RIGHT$ ( str len -- str2 )		OVER LEN$ SWAP - + ;
pub LEFT$ ( str len -- str2 )		OVER+ C~ ;





( *** INPUT/OUTPUT *** )


--- *** I/O and REGISTERS ***

PUBLIC
$01F0	:= SPR
$01F0	:= PAR
$01F1	:= CNT
$01F2	:= INA
$01F3	:= INB
$01F4	:= OUTA
$01F5	:= OUTB
$01F6	:= DIRA
$01F7	:= DIRB
$01F8	:= CTRA
$01F9	:= CTRB
$01FA	:= FRQA
$01FB	:= FRQB
$01FC	:= PHSA
$01FD	:= PHSB
$01FE	:= VCFG
$01FF	:= VSCL

\ pub SPR!	SPR + COG! ;
IFNDEF P@
pub P@		INA COG@ ;

pub P!		OUTA COG! ;
}

pub CNT@		CNT COG@ ;
pub =CNT ( addr -- )	CNT@ SWAP ! ;
pub CNT?  ( cycles var -- flg )	@ CNT@ SWAP - SWAP > ;

IFNDEF PIN!
pub PIN! ( bit pin -- )		MASK
}
pub OUT				DUP OUTPUTS SWAP SHROUT 2DROP ;


\ Read input pins and right justify and mask - #P8 4 PINS@ - reads P8..P11 as a nibble
pub PINS@ ( pin for – n ) 	P@ ROT >> SWAP MASK 1- AND ;
{
READPINS
		mov 	X,INA
		shr 	X,tos+1
		mov 	tos1,X
BITS		call 	#AMASK
		and 	tos1,tos
		jmp 	#DROP
}





{
PRIVATE
16 longs locals
locals 4 +	:= @x2
locals 8 +	:= @x3
locals 12 +	:= @x4

pri @X		4* locals + ;
pub X1		locals @ ;
pub X2		@x2 @ ;
pub X3		@x3 @ ;
pub X4		@x4 @ ;

--- pop the n top stack elements to the local space, TOS => X1, TOS+1 => X2 ..
pub LOCAL ( <data> n --  )
	DUP 4* ( <data> n bytes )
	locals 2DUP + ROT <CMOVE
	FOR I @X ! NEXT
	;

--- pop and release emove n elements from locals, of no longer used )
pub RELEASE ( n -- )		DUP @X locals ROT 4* $40 SWAP - CMOVE ;
\ locals $40 ERASE			\ Clean out the locals (easier for debugging)

}

\ pub LONGFILL ( addr cnt longval --  )		3RD ! OVER CELL+ SWAP 1- 4* CMOVE ;

PRIVATE
long seed

\ COMMENT: RND ( -- n )  Generate a 32-bit pseudo-random number enhanced with the system counter
pub RND ( -- n    \ 32 bit pseudo random number enhanced with system counter )
 	seed @ DUP 13 << XOR
 	DUP 17 >> XOR
 	DUP 5 << XOR
 	CNT@ * DUP seed !			\ randomize the result as well using the system CNT
 	;







--- Find the next available cog that's free to run a task - ready and in IDLE
pub TASK? ( -- task )
	8 BEGIN 1- DUP TASK @ $1.0000 = OVER 0< OR UNTIL
	;


pub RUN ( pfa cog -- | USAGE: ' MYTASK TASK? RUN )
 	DUP 0 7 WITHIN IF TASK W! ELSE CR PRINT" Error - cog out of range " THEN
 	;
--- run following code as a task in cog n
pub RUN: ( n <code> -- )	R> SWAP RUN ;
--- example: pri SENSORS	3 RUN: BEGIN 12 13 DISTANCE mm W! 15 DHT 'c W! rh W! 60 ms AGAIN ;


\ Set starting address of a task's registers
pub TASKREGS ( addr -- )		8 COG! ;

pub COGINIT ( code pars cog -- ret ) 	 SWAP 16 << OR SWAP 2 << OR pCOGINIT ;
















	( *** NUMBER PRINT FORMATTING *** )

--- --- --- --- --- --- --- --- --- --- ---
{
..  123456 .AS" $~###,###,##~#.##"    $1,234.56 ok
..  1234 .AS" 8|~"   00001234 ok
..  1234 .AS" 8|`"       1234 ok
}

byte pflg
byte pbase

pri D0=		2DUP OR 0= ;

pri #NUM	D0= 2 pflg SET? AND IF $20 ELSE pbase C@ UM/DMOD ROT >CHAR THEN HOLD ;

--- usable command characters	~ ` | \ ^ _
pri AS#
	SWITCH
	4 pflg SET? NOT 4 pflg CLR
	IF
	'|' CASE 4 pflg SET BREAK
---	toggle lzs
	'~' CASE 1 pflg TOG BREAK
---	pad leading zeros with spaces?
	'`' CASE 2 pflg TOG BREAK
---	skip over leading zeros?
	D0= 1 pflg SET? AND ?EXIT
	'#' CASE #NUM BREAK
	ELSE
	'$' CASE 16 pbase C! BREAK
	'*' CASE BEGIN D0= NOT WHILE #NUM REPEAT BREAK
	SWITCH@ '3' '9' WITHIN IF SWITCH@ '0' - FOR #NUM NEXT EXIT THEN
	THEN
	SWITCH@ HOLD
	;

pub .AS ( num format -- )
	12 REG @ SWAP  pflg C~ 10 pbase C!
	<# DUP LEN$ 1- OVER+ FROM -1 BY LEN$
	  FOR I C@ AS# NEXT  DROP
	#> PRINT$
	;

--- runtime of .AS"
pri .AST 	R> DUP LEN$ 2+ 1 ANDN OVER+ >R .AS ;

--- compile a .AS format and print
pre .AS"   	' .AST [C] [W] [C] ["] ;


--- --- --- --- --- --- --- --- --- --- ---

--- Print a formatted decimal number with 4 digits
pub .DEC4  	.AS" ###`#" ;
--- Print a decimal number with standard separators
pub .DECL 	.AS" ###,###,###,###,##~#" ;
pub .DEC2	.AS" ## " ;
pub .DEC2.	.AS" ##." ;

pri ~1			DUP 24 >> .AS" ##~#" 8<< ;

--- Print an IP style formatted number i.e. &192.168.0.16
pub PRINT&		'&' EMIT ~1 DOT ~1 DOT ~1 DOT ~1 DROP ;

pub .BIN16		16 FOR DUP 15 >> >b $30 + EMIT 2* NEXT DROP ;
pub .BIN32		L>W '%' EMIT .BIN16 '_' EMIT .BIN16 ;

\ ..  0 @ .BIN32 %0000_0101_1011_1000_1101_1000_0000_0000 ok


--- ---






--- *** ANSI TERMINAL SUPPORT ***


PUBLIC
--- ANSI color values ---
0	:= black
1	:= red
2	:= green
3	:= yellow
4	:= blue
5	:= magenta
6	:= cyan
7	:= white

PRIVATE
long _ansi
pri ANSI?			uemit W@ 0= _ansi @ 0<> AND ;
pri AEMIT			ANSI? IF EMIT ELSE DROP THEN ;
pub ESC ( ch -- )		$1B AEMIT AEMIT ;

pub HOME			'H'
pri ESCB ( ch -- )		'[' ESC AEMIT ;

pub PEN ( col -- )		7 AND '3'
pri COL ( col fg/bg -- )	ESCB '0' + AEMIT 'm' AEMIT ;
pub PAPER ( col -- )		'4' COL ;

{ optional - normally not supported
pri ESCH ( ch -- )		"#" ESC EMIT ;
pub DHT				"3" ESCH ;
pub DHB				"4" ESCH ;
pub NARROW			"5" ESCH ;
pub WIDE			"6" ESCH ;
}

pri CUR ( cmd n -- )		'[' ESC SWAP
pri .PAR			SWAP ANSI? IF .AS" ##~#" ELSE DROP THEN AEMIT ;
pub XY ( x y -- )		';' SWAP CUR 'H' .PAR ;


pub CLS 			$0C EMIT ;
--- Erase the screen from the current location
pub ERSCN			'2' ESCB 'J' AEMIT ;
--- Erase the current line
pub ERLINE			'2' ESCB 'K' AEMIT ;


pub CURSOR ( on/off -- )	'?' ESCB 25 .
pri asw				IF 'h' ELSE 'l' THEN AEMIT ;

pub PLAIN			'0'
pri ATR ( ch -- )		ESCB 'm' AEMIT ;
pub REVERSE			'7' ATR ;
pub BOLD			'1' ATR ;

pub WRAP ( on/off -- )		'?' ESCB '7' AEMIT asw ;

pub MARGINS ( top bottom -- )	'[' ESC SWAP ':' .PAR 'r' .PAR ;

--- res = 1B5B.306E
pub ?ANSI 			 _ansi ~~ '5' ESCB 'n' EMIT 100 ms 0 4 FOR 8<< KEY OR NEXT _ansi ! ;


{
pri CSI ( n1 n2 -- )		$C2 EMIT $9B EMIT 2 FOR ?DUP IF EMIT THEN NEXT ;
pri CNUM			0 BEGIN WKEY DUP $30 $39 WITHIN WHILE $30 - SWAP 10 * + REPEAT DROP ;
pub XY@				$6E $36 CSI 8 EMIT SPACE 8 EMIT WKEY DROP WKEY DROP CNUM CNUM SWAP ;

--- list all color combos
8 for cr i pen 8 for i paper print" hello "   next  plain next
}



pub .HEAD$			BOLD PRINT" *** " PRINT$ PRINT"  ***" PLAIN ;

pub .CFA ( cfa -- )		DUP NFA ?DUP IF .NFA SPACE THEN $7FFF AND .WORD ;





--- execute valid inits - empty positions are filled with a NOP or an EXIT
pub INIT		EXIT EXIT EXIT EXIT EXIT EXIT EXIT EXIT EXIT EXIT EXIT EXIT EXIT EXIT EXIT EXIT   ;

pub +INIT		' INIT BEGIN DUP W@ ' EXIT <> WHILE 2+ REPEAT W! ;

pub !INITS 		' EXIT ' INIT W! ' INIT DUP 2+ 28 CMOVE ;

{
pubatr  = 0
priatr  = 1
preatr  = 2
modatr  = 3
maxlen  = 15
}
{
pre AWORDS
	1 2 REG W!
	-1 0 REG W! lastkey C@ $0D <>
	IF GETWORD 1- SEARCH DUP 0= IF @WORD C@ 0 REG W! THEN
	ELSE @NAMES THEN
	@NAMES MAX
	BEGIN DUP W@ 0 REG W@ 0<> AND
	WHILE
	CR 2 REG W@ .DEC4 SPACE 2 REG W++
	DUP +NFA 2- W@ .WORD SPACE
	DUP .WORD SPACE DUP C@
	6 >> 3 * " pubpripremod" + 3 CTYPE SPACE
	DUP .NFA +NFA
	-1 0 REG W+!
	REPEAT DROP
	;
}




(	*** RECLAIM HEADERS & CODE ***		)
{

' Dictionary header attribute flags
sm      = |<7           'smudge bit - set to deactivate word during definition
im      = |<6           'lexicon immediate bit
pr      = |<5           'private (can be removed from the dictionary)

0   1 2 3 4 5 6  7  8  9
$25,S,T,R,I,P,WL,WH,XX,XX
$26,F,O,R,G,E,T,00,WL,WH,XX,XX
}
--- strip name by moving newer words over

pri (STRIP) ( nfa -- nfa+ )
	CR ." Removing " DUP .NFA
	DUP C@ >N CELL+ 1 ANDN SWAP ( nfalen nfa )
	@NAMES DUP 4TH + ( nfalen nfa names newnames )
	3RD @NAMES - ( nfalen nfa names newnames blken ) <CMOVE
	( nfalen nfa ) OVER+ ( nfalen nfa+ )
	SWAP names W+!
	;

--- Strip a single header from the dictionary
pre STRIP			[C] NFA' GRAB (STRIP) DROP;

--- RECLAIM <opt>

pre RECLAIM
	--- reclaim <from> or all
	lastkey C@ $20 = IF [C] NFA' ELSE $8000 THEN
	@NAMES DUP 1!
	BEGIN
	--- Test to see if this is private
\ 	  DUP $10 DUMP
  	  DUP C@ 6 >> 1 =
  	     --- strip header or proceed to next
  	    IF (STRIP) ELSE +NFA THEN
	  --- forced limit?
	  2DUP U<
	  --- end of dict?
 	  OVER W@ 0= OR
	UNTIL
	--- Report results
	2DROP CR ." Reclaimed " @NAMES 1@ - DUP .AS" ##,#~## bytes"
	--- Clear the reclaimed area (not needed)
	1@ SWAP ?DUP IF ERASE ELSE DROP THEN
	;



pre FORGET ( <name> -- )
 	[C] NFA'
--- find the NFA of the word
pub (FORGET) ( nfa -- )
	?DUP
 	IF
	  CPA DUP W@ $200 BUFFERS WITHIN
	   IF
	     DUP W@ uhere W!
	     2+ names W!
              HERE uthere W!
	     ' EXIT HERE W!
	   ELSE
	     DROP PRINT"  Unforgettable word"
	   THEN
	ELSE
          SPACE @WORD PRINT$ PRINT"  not found "
	THEN
	!INITS
	;




--- REVECTOR oldcode newcode  - Replaces first instruction of oldcode with jump to newcode
pre REVECTOR			1
pri ~v				[C] ' [C] ' GRAB ROT + SWAP W! ;
--- insert a call over first instruction
pre +VECTOR			0 ~v ;

---				oldcode trapcode
pri trap 			NOP	NOP ;
pre TRAP ( name to -- )		[C] ' [C] ' GRAB ' trap 2+ W! DUP W@ ' trap W! ' trap SWAP W! ;



(	*** SIMPLE SERIAL ***	)


--- create a user variable (volatile)
\ pub baudcnt		16 REG ;
16 reg baudcnt

--- SERBAUD   set simple serial baud rate ( 1200 baud minimum )
---				calc bit ticks   and set   as well as start bit compensation
pub SERBAUD ( baud -- )		CLKFREQ SWAP U/ DUP baudcnt W! 2/ 200 - baudcnt 2+ W! ;

\ 9600 SERBAUD

pri TXSER
	baudcnt W@ WAITX
	WAITCNT SHROUT WAITCNT SHROUT
	WAITCNT SHROUT WAITCNT SHROUT
	WAITCNT SHROUT WAITCNT SHROUT
	WAITCNT SHROUT WAITCNT SHROUT
	WAITCNT SHROUT WAITCNT
	DROP
	;
pub SEROUT ( data pin -- )
	MASK H SWAP 2*
	TXSER OUTSET
	;

pub ISEROUT ( data pin -- )
	MASK L SWAP 2* $7FF XOR
	TXSER OUTCLR
	;


--- redirect character output to seleect serial channel using SEROUT
pri ~S			0 SEROUT ;
pub SERIAL ( pin -- )	' ~S C! ' ~S uemit W! ;




--- redirect character output to seleect serial channel using SEROUT
pri ~S			0 ISEROUT ;
pub ISERIAL ( pin -- )	' ~S C! ' ~S uemit W! ;



--- receive 8 bit serial data from pin at rate set with SERBAUD, blocks until character received
pub SERIN ( pin -- data  )
	MASK DUP 4 COG!					--- [5.8us]
 	baudcnt 2+ W@					--- [4.8us] serup half-bit delay with high speed compensation
	WAITHI						--- [0.4us+] make sure we are not detecting the last data bit - wait for stop
	WAITLO WAITX 					--- wait for start bit then wait haf bit time
	 0							--- [5.4us] setup pin mask and inital data to SHRINP 8 data
	baudcnt W@ WAITX 					--- delay to sample 1 bit later in 1st data bit
	SHRINP WAITCNT
	SHRINP WAITCNT
	SHRINP WAITCNT
	SHRINP WAITCNT
	SHRINP WAITCNT
	SHRINP WAITCNT
	SHRINP WAITCNT
	SHRINP							--- last data bit
	NIP #24 >>						--- right justify 8-bit data
	;


(	*** COUNTERS ***	 )
PRIVATE
--- latch the selected counter A or B (0 or 1)
byte _ctr

--- Select the desired target CTR A or B before use
pub A				_ctr C~ ;
pub B				1 _ctr C! ;

pri CTR ( -- addr )		CTRA
pri ~C				_ctr C@ >b + ;
pri CTR@ ( -- val )		CTR COG@ ;

--- Set NCO counter mode
pub NCO				4
--- Writes to the CTRMODE field of the current CTR channel without disturbing the other bits of the counter
pub CTRMODE ( n -- )		26 <<	CTR@ $7C000000
pri ~1 				ANDN OR
pri CTR! ( val -- )		CTR COG! ;

--- Change counter mode to differential
pub DIFF			CTR@ $400.0000 OR CTR! ;

--- SetDuty counter mode
pub DUTY			6 CTRMODE ;
pub PLL				2 CTRMODE ;
pub PLLDIV ( n -- )		23 << CTR@ $0380.0000 ~1 ;

--- Set the APIN of the current CTR
pub APIN ( pin -- )		CTR@ $1F ~1 ;
--- Set the BPIN of the current CTR
pub BPIN ( pin -- )		9 << CTR@ $3E00 ~1 ;


--- Write an 8-bit value to the pin as a duty cycle - filter output for a voltage

pub DAC! ( byte pin -- )	DUP LOW APIN DUTY 24 <<
--- Set the value of the current FRQ either A or B
pub FRQ ( n --  )		FRQA ~C COG! ;

pub VOLTS ( volts.nnn pin -- )
	DUP LOW APIN ABS 3300 MIN 130150524 1000 */ DUTY FRQ
	;



pub MHZ ( MHz -- )		1,000 *
pub KHZ ( khz -- )		1,000 *
pub HZ ( hz -- )		NCO HZCON 10,000 */ FRQ	CTR@ $1F AND LOW ;
pub MUTE			CTR@ $1F AND FLOAT OFF CTRMODE ;


pri *spkr 			0 ;
pub SPKR ( pin -- )		' *spkr C! ;
pub CLICK      			*spkr DUP HIGH 100 us LOW ;
pub BEEP    			2250 150
pub TONE ( tone dur -- )    	SWAP A *spkr APIN HZ ms MUTE ;
pub BEEPS ( cnt -- )     	FOR BEEP 50 ms NEXT ;
pub BIP    			3000 80 TONE ;
pub WARBLE ( hz1 hz2 ms -- )    3 FOR 3RD OVER TONE 2DUP TONE NEXT 3DROP ;
pub SIREN			400 550 400 WARBLE ;
pri ~1 				500 600 40 WARBLE ;
pub RING 			~1 200 ms ~1 ;
pub RINGS ( rings -- )  	FOR RING 1 s NEXT ;


--- blinky using counters - also useful for setting up a pin quickly - then use HZ etc
pub BLINK ( pin -- )		APIN 2 HZ ;


---			*** I2C DRIVER ***

PUBLIC
\ 28		:= *SCL
\ 29		:= *SDA
--- Programmable pin constants
pub *SCL	28 ;
pub *SDA	29 ;

1		:= @SCK
@SCK 1 +	:= @MOSI
@SCK 2 +	:= @MISO
@SCK 3 +	:= @CE
@SCK 4 +	:= @CNT

15		:= @SCL
10		:= @SPISCK


\ pri MASK? ( n -- mask )		>B DUP 32 U< IF MASK ELSE DROP 0 THEN ;
\ pri MASK? ( n -- mask )		>B DUP 5 >> IF DROP 0 ELSE MASK THEN ;

--- Set the SPI pins using a long as 4 octets = &ce.miso.mosi.clk  as this allows passing a single long
pub SPIPINS ( &ce.miso.mosi.clk --- )  ( 20us )
 	@SPISCK
pub SETPINS ( &pins dst -- )  ( ~190us)
  	1!
	DUP MASK L 1@ COG! 8>> 1++
	DUP MASK L 1@ COG! 8>> 1++
	DUP MASK F 1@ COG! 8>> 1++
	MASK H 1@ COG!
	;

pub MODPINS  	@SCK SETPINS ;


{
--- Example of outputting an array of 100 LEDs
( 1452 $2A86 ok )   300 bytes matrix
( 1453 $2A86 ok )   22 LEDPIN LAP matrix 100 LEDS LAP .LAP  243072 cycles at 96000000Hz  or 2.532ms
( 1454 $2A86 ok )

--- running in the background
300 bytes matrix
pub MYLEDS   22 LEDPIN BEGIN matrix 100 LEDS AGAIN ;
' MYLEDS 3 RUN
}





---			*** I2C DRIVER ***

byte i2cflg

--- wait but timeout while busy
pub ?I2C	i2cflg C@ IF 1500 BEGIN 1- i2cflg C@ 0= OVER 0= OR UNTIL DROP i2cflg C~  THEN ;



pub <I2C
	?I2C
pub <I2C>	--- restart without checking busy
	*SDA FLOAT *SCL HIGH
	--- setup mask for CLOCK instruction
 	*SCL MASK @SCL COG!
	*SDA LOW 1 i2cflg C! *SCL LOW
	;


{ I2C STOP CONDITION also releases I2C lines
 SCL XX-------:=
 SDA XX___----:=
}
pub I2C>
	--- pull SDA high from low while clock high
	*SDA LOW *SCL HIGH ( 1 DROP ) *SDA HIGH
	--- free up I2C lines
 	*SDA FLOAT *SCL FLOAT
 	i2cflg C~						--- i2c bus free
	;

\ ALIAS <I2C I2CSTART
\ ALIAS I2C> I2CSTOP


--- Write a byte to the I2C bus and return with the ack flag
--- This routine runs at an I2C speed of 400kHz
--- 38.4us
--- write a byte to the I2C bus and return with the ack  0=ack	)
pub I2C!? ( data -- flg )
	#24 REV
	--- data masks
	*SDA DUP HIGH MASK SWAP
	8 FOR SHROUT  CLOCK CLOCK  NEXT
	DROP DUP INPUTS						--- Float SDA
	CLOCK IN  CLOCK					--- ack clock
	;


{
--- write a byte to the I2C bus and return with the ack  0=ack	)
pub I2C!? ( data -- flg )
	24 <<
	--- data masks
	*SDA MASK SWAP
	8 FOR CLKOUT NEXT
	--- Float SDA for ACK
	DROP DUP INPUTS CLOCK IN 0<> CLOCK
	;
}
pub I2C!			I2C!? DROP ;

pub ackI2C@ 	0
--- 25.5us @96MHz
--- Fetch a byte from the I2C bus - mirror ack signal 0 in = 0 out
pub I2C@	( ack -- data  )
	*SDA DUP FLOAT MASK 0  ( ack iomask dat )
\	  8 FOR CLKIN CLOCK NEXT
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK

	--- make SDA an high output
	OVER OUTSET
	--- clock out ack bit
	-ROT SWAP CLKOUT DROP CLOCK INPUTS
 	;

pub nakI2C@	TRUE I2C@ ;

\ ALIAS ackI2C@ FI2C@
{
--- 16.33us @96MHz
pub FI2C@ ( -- byte )
	*SDA DUP FLOAT MASK 0  ( iomask dat )
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  OVER OUTCLR
	CLOCK CLOCK SWAP INPUTS
	;
}
{
pub I2CADR ( adr -- ack )	<I2C I2C! NOT ;
pub 2W! ( 16b adr -- )		I2CADR DROP DUP I2C! 8>> I2C! ;
pub 2C! ( 8b adr -- )		I2CADR DROP I2C! ;
pub 2C@ ( adr -- 8b )		I2CADR DROP 1 I2C@ ;
pub 2W@ ( adr -- 16b )		I2CADR DROP ackI2C@ 1 I2C@ 8<< OR ;


}
--- Control the speed of the I2C bus
--- The CLOCK instruction can be slowed down at 16 COG!
pub I2CFAST	0
pri ~D		16 COG! ;
pub I2C100	CLKMHZ ~D ;
pub I2C400	CLKMHZ 12 / ~D ;

I2C400


( EEPROM )
byte eeadr
--- EEPROM addressing - select default device and write 16-bit address
--- Updated to take an address >64K and automatically select the next device

--- use full 32-bit address to select a device and issue the lower 16-bit address to it
pub @EE ( addr -- flg )  ( 17408 cycles at 96000000Hz  or 181.333us )
	I2CFAST
	--- wait if busy then terminate any I2C activity
	?I2C I2C>
	--- calculate the device address with base $A0 (8-bits)
	L>W 2* $A0 + DUP eeadr C!
	--- send the device address
	<I2C> I2C!?
	--- send the 16-bit memory address (msb)
	OVER 8>> I2C!?
	--- send the lsb and return with a combined ack flag.
	OR SWAP I2C!? OR
	;

--- revision 140602 - Added timeout loop counter to prevent hanging
pub @EEWAIT ( adr --  ) ( 180.4us timeout )
---	timeout   cnt  read ee rdy? cnt0  either until
  	40 BEGIN 1- OVER @EE 0= OVER 0= OR UNTIL 2DROP
	;

pri EERDW			@EEWAIT
--- Switch EEPROM to read mode ( 56.2us )
pub EERD ( -- ) 		<I2C> eeadr C@ 1+ I2C!? DROP ;

--- read last byte [no ack] and stop
pri ENDRD			nakI2C@ DROP I2C> ;

--- Store byte to EEPROM ( 234us )
pub EC! ( byte addr -- ) 	@EEWAIT I2C! I2C> ;

--- Fetch byte from EEPROM
pub EC@ ( addr -- byte ) 	EERDW nakI2C@ I2C> ;

--- Fetch word from EEPROM ( 273us )
pub EW! ( word addr -- )	@EEWAIT W>B SWAP I2C! I2C! I2C> ;

--- Fetch a word from EEPROM
pub EW@ ( addr -- word ) 	EERDW ackI2C@ nakI2C@ B>W I2C> ;

--- Fetch a long from EEPROM
pub E@ ( addr -- long )
 	EERDW ackI2C@ ackI2C@ B>W ackI2C@ nakI2C@ B>W I2C>
 	W>L
 	;

pub E! ( long addr -- ) ( 356us )
 	@EEWAIT L>W SWAP W>B SWAP I2C! I2C!
 	W>B SWAP I2C! I2C! I2C>
  	;

pub ESAVEB ( ram eeprom cnt -- \ byte by byte method - safer for non-page aligned addresses and counts )
	SWAP FROM
 	FOR C@++ I EC! ( 5 ms SPINNER ) NEXT DROP
 	;



pub EEPROM			29 28
pub I2CPINS ( sda scl -- )	' *SCL WW! ' *SDA WW! ;

--- calculate EEPROM programming page size basd on memory size

$FFFC E@
  $A55A5AA5 $FFFC E! $FFFC E@ $7FFC E@ <> IF 128 ELSE 64 THEN		:= ep
$FFFC E!


--- Save a block of RAM to EEPROM. Will backup 32K to EEPROM in 4.963 seconds

pub ESAVE ( ram eeprom cnt -- )
	--- round up to nearest 64 byte page --- use ram address for loop index, leave eeprom addr on stack
	ROT FROM   ep ALIGN ep BY ep U/
	FOR
   	( eeprom )
	  --- Wait for the EEPROM write cycle
   	  DUP EERDW 0
	  I FROM ep
 	    FOR ackI2C@ I C@ <> OR DUP IF LEAVE THEN NEXT
	   nakI2C@ DROP I2C>
	   IF
	     --- Write 64 bytes and check acks
 	     DUP @EE DROP 0 I FROM ep FOR I C@ I2C!? OR NEXT I2C>
	     IF <CR> ." FAIL @" DUP .WORD THEN
	   THEN
	   --- console spinner to show it's busy
    	   SPINNER  ep +
  	NEXT
	DROP
 	;

--- Load a block of EEPROM to RAM
pub ELOAD ( eeprom ram cnt -- )
	ROT EERDW				--- select the device - might have to wait
	SWAP FROM
	  FOR ackI2C@ I C! NEXT				--- sequential reading from EEPROM into RAM
	ENDRD						--- signal last byte read
 	;

pub EFILL ( src cnt ch -- )				--- fill EEPROM from src address with cnt times byte ch)
	ROT FROM
	ep BY
	SWAP ep /
 	FOR (  ch )
	  I @EEWAIT					--- write address but wait if necessary
	  ep FOR DUP I2C! NEXT I2C>			--- store one page's worth of data to EEPROM and write
	NEXT DROP
	;


--- copy cnt bytes from eesrc to eedst )
pub ECOPY ( eesrc eedst cnt -- )
	SWAP FROM ep BY ep /
	FOR
	  DUP BUFFERS ep ELOAD
	  BUFFERS I ep ESAVE
	ep +
	NEXT DROP
	;

{
: ECHECK
	0 $8000 ADO
	0 I 64 ADO I C@ I EC@ <> OR LOOP
	IF
	I 64 ADO
	I $3F AND 0= IF CR I .LONG SPACE THEN
	I >N 0= IF SPACE THEN
	I C@ I EC@ <> IF I .HEX ELSE ." ." THEN
	LOOP
	THEN
	64 +LOOP
	;

}
--- Select EEPROM device for DUMP command access
--- Usage: 0 $100 EE DUMP
pub EE		DUMP: EC@ EW@ E@ ;




--- Only backup if there are no errors recorded
pub ?BACKUP
 	errors W@ NOT 0EXIT
	--- Backup the current Tachyon Forth session
pub BACKUP
	EEPROM
	PRINT" BACKUP "
	0 0 $7400 ESAVE
	;


pub CONBAUD ( baud -- \ Set TACHYON's baudrate for next reboot  )
	CLKFREQ SWAP / DUP $28 ! $28 E!
	;



(		*** PCF8574 style I2C I/O ***	)

pub IO@ ( device -- data )		<I2C 1+ I2C! ackI2C@ I2C> ;

pub IO! ( data device -- )		<I2C I2C! I2C! I2C> ;



--- Set word to auto run at boot
pre AUTORUN ( <name> -- )	[C] ' GRAB DUP uauto W! uauto EW! 	;









(	*** RTC and TIMERS ***		)




( REAL-TIME CLOCK )

{ HELP TIMER ( <name> -- )
create a timer variable (replaces DOUBLE)
ms(4), alarm/mode(2), link(2), tid(1), nu(1), nu(2)
}
pre TIMER			4 ALIGNORG @org W@ 16 ERASE 4 [C] longs ;

\ pre TIMER          4 ALIGNORG CREATE @org W@ DUP W, 16 ERASE 16 DS+ DOES> R> W@ ;

\ Define variables used by the background timer cog

PUBLIC
1 cword timers		--- link to timers - set to 1 as last
PRIVATE
byte tid		--- timer ID signature (match to this indicates timers linked )

CLKFREQ #1000 / := ttint				\ define the timing constant ( writable constant )

( Background timer API )

{ New timer methods that allow modules to link their timers into the background countdown process
add a timer to the list of timers to countdown,
addr points to 2 longs, first is the timer, second is both the alarm word and the link word
last timer has a link word of 0
link->TIMER3->TIMER2->TIMER1->0
}
pub TIMEOUT ( ms addr -- \ Set the timeout period in ms for this timer - link and init if not already set )
 	SWAP OVER ! --- set it and link it if it has not been linked yet
pri +TIMER ( addr -- )
	--- discard and ignore if already linked
 	DUP 8 + C@ tid C@ = IF DROP EXIT THEN
	--- set tid
 	tid C@ OVER 8 + C!
	--- link in new timer (first one is set to 1 )
   	timers W@ OVER 6 + W!
	--- save latest in timers
 	timers W!
	;

pub COUNTUP ( addr -- \ countup timer mode )
 	1 SWAP
	DUP +TIMER
pub ALARM ( pfa addr -- \ Set an alarm action to perform once timeout occurs )
	CELL+ W!
	;
pub TIMEOUT? ( addr -- flg \ check if this timer has timed out )
	@ 0=
	;

--- use to setup timer code easily:    50 mytimer ALARM: <inline alarm code follows> ;
pub ALARM: ( val tmr : code -- ) 2DUP TIMEOUT R> SWAP ALARM ;


TIMER wdt
pub WATCHDOG ( ms -- )		wdt TIMEOUT ;


PUBLIC
long	runtime

PRIVATE
8 bytes rtcbuf

4 bytes @time
4 bytes @date
2 bytes @day


pri rtcbuf@	rtcbuf + C@ ;
pri rtcbuf!	rtcbuf + C! ;



--- I2C RTC DRIVERS ---

--- RTC I2C ADDRESS psuedo constant
pub @rtc		0 ;

--- selects type of I2C RTC chip used
--- DS3231 is fairly generic f
pub DS3231		$D0
pri =rtc		' @rtc WW! ;
pub MCP79410	$DE =rtc ;
pub RTCEE		$AE =rtc ;		--- EEPROM of MCP79410 - access with RTC@/RTC!
pub NORTC		0 =rtc ;


pri <RTC			I2C400 <I2C @rtc I2C! ;
--- Start and address RTC device
--- restart and read RTC device
pri <RTC>			<I2C> @rtc 1+ I2C! ;

--- Read first 8 timekeeping bytes of RTC into rtcbuf
pub RDRTC
	@rtc 0EXIT <RTC 0 I2C! <RTC>
	  rtcbuf FROM 8 FOR ackI2C@ I C! NEXT nakI2C@ DROP I2C>
	;

--- Write first 8 timekeeping bytes of RTC from rtcbuf
pub WRRTC
	@rtc 0EXIT <RTC 0 I2C!
	;
	  rtcbuf FROM 8 FOR I C@ I2C! NEXT I2C>

pub RTC! ( byte addr -- )	<RTC I2C! I2C! I2C> ;

pub RTC@ ( addr -- byte )	<RTC I2C! <RTC> nakI2C@ I2C> ;
\ pub RTCW@ 					DUP RTC@ 8<< SWAP 1+ RTC@ + ;

--- Select RTC as a DUMP device - byte method only
pub RTC						DUMP: RTC@ RTC@ RTC@ ;

pub BCD>DEC ( bcd -- dec )	DUP >N SWAP 4 >> 10 * + ;

pub DEC>BCD ( dec -- bcd )	10 U/MOD 4 << + ;

--- read HHMMSS time in decimal format
pub TIME@ ( -- #hhmmss )
    @time @ 1000 /
    60 U/MOD ( sec x ) 60 U/MOD ( sec mins hrs ) 24 MOD 10000 * SWAP 100 * + +
    ;

--- split 6 digit decimal number into 3 two digit groups
pub HMS ( #xxyyzz -- zz yy xx )		100 U/MOD 100 U/MOD ;

--- read international date in decimal format
pub DATE@ ( -- #yymmdd )
	@date @ DUP 0= IF DROP 010101 THEN
	;

pub TIME! ( hh.mm.ss -- )
	0
--- write time/date in decimal format where d/t = 4 for date
pub DT! ( hh.mm.ss|yy.mm.dd d/t -- )
	@rtc
	IF
	  RDRTC
	  4 AND 2DUP @time + !
	  OVER HMS ( yymmdd n dd mm yy )
	  DEC>BCD 4TH 2+ rtcbuf!
	  DEC>BCD 3RD 1+ rtcbuf!
	  DUP @day 1+ C!
	  --- ensure some RTC devices have a 'RUN' bit set otherwised it is ignored.
          DEC>BCD $80 OR OVER rtcbuf!
	  WRRTC
	THEN
--- write soft time/date in decimal format where d/t = 4 for date
pub SDT! ( hh.mm.ss|yy.mm.dd d/t -- )
	4 AND DUP NOT
	  IF DROP HMS 60 * SWAP + 60 * + 1000 * 0 THEN
	@time + !  --- time stored in milliseconds
	;

pub DATE! ( yy.mm.dd -- )	4 DT! ;

--- Days of the week constants
PUBLIC
1 := MON
2 := TUE
3 := WED
4 := THU
5 := FRI
6 := SAT
7 := SUN

pub DAY@ ( -- day )			@day C@ 1 MAX ;

--- set DAY as in MON DAY etc
pub DAY ( day -- )
     DUP @day C!
     @rtc IF 3 rtcbuf@ 7 ANDN + 3 rtcbuf! WRRTC ELSE DROP THEN
     ;

pub .DAY ( n -- )	1 7 LIMIT 1-  3 * " MonTueWedThuFriSatSun" + 3 CTYPE ;

pub .TIME     	TIME@
pri .TIMEF	.AS" ##:##:##" ;
--- Print date in international format YYYY/MM/DD
pub .DATE        DATE@
pri .DATEF	.AS" 20##/##/##" ;


pub .ASMONTH ( index -- )
    >N 1- 3 * " JanFebMarAprMayJunJulAugSepOctNovDec" + 3 CTYPE
    ;


clong tz$ 0 ,
pub TZ ( str -- )	tz$ $! tz$ DUP 8 ESAVEB ;


pub .DT		TIME@ DATE@ DAY@
( Tue, 03 Dec 2013 04:19:05 GMT )
pri .DTS ( time date day -- )
	.DAY ',' EMIT HMS
	ROT .AS"  ## "
	SWAP .ASMONTH .AS"  20## "
	.AS" ##:##:## " tz$ PRINT$
	;

{

TACHYON
1	:= January
2	:= February
3	:= March
4	:= April
5	:= May
6	:= June
7	:= July
8	:= August
9	:= September
10	:= October
11	:= November
12	:= December

pub am ;
pre pm			1200 + ;

pri SetClock		10000 * SWAP 100 * + + DATE! DAY 100 * TIME! ;
pre Monday, 1		DEFER SetClock ;
pre Tuesday, 2		DEFER SetClock ;
pre Wednesday, 3	DEFER SetClock ;
pre Thursday, 4		DEFER SetClock ;
pre Friday, 5		DEFER SetClock ;
pre Saturday, 6		DEFER SetClock ;
pre Sunday, 7		DEFER SetClock ;
END


5:29 pm
Monday, 23 October 2017



}


--- STAMP@ returns a 32-bit millisecond time + day of month in top 5-bits
pub STAMP@ ( --- dhmsc )	@time @ @day 1+ C@ 27 << + ;


--- read temperature from DS3231
pub 'C ( -- 'C*100 )		@rtc IF $12 RTC@ $11 RTC@ B>W 6 >> 25 * ELSE 0 THEN ;
pub 'F ( -- 'F*100 )		'C 9 5 */ 3200 + ;
\ pub .TEMP			'C <# # # '.' HOLD #S #> PRINT$ PRINT" 'C " ;
pub .TEMP			'C .AS" #~#.##'C "  ;

( TIMERS )
--- Maintain chained list of TIMERS
--- by default count down 32-bits to zero every millisecond if set
pri CountDown
	--- next timer
	timers W@
 	BEGIN
	  --- link to another timer?
 	  DUP $FF >
	WHILE
	  --- count up mode? (ALARM=1)
 	  DUP CELL+ W@ 1 =
 	  IF
	    --- simple count up mode
 	    DUP ++
 	  ELSE --- count down if non-zero
 	    DUP @ ?DUP
 	    IF
	      --- decrement non-zero timer and udate
 	      1- DUP 3RD !
	        --- if now zero then execute valid alarm if set
 	        0= IF DUP CELL+ W@ DUP 4 >>
 	          IF CALL ELSE DROP THEN
 	        THEN
 	    THEN
 	  THEN
	  --- follow link to next timer
 	  6 + W@
 	REPEAT
 	DROP
	;


{ DS3231 REGISTERS  --- typical arrangement of most RTCs with minor differences

	7	6	5	4	3	2	1	0
00	0	----10 seconds---	------ seconds ----------
01	0	----10 minutes---	------ minutes ----------
02	0	12/24	PM --------------- hours ----------------
03	0	0	0	0	0	----- day -------
04	0	0	--date---	---------- date ---------
05	cent	0	0	--------- month -----------------
06	--------- 10 year -------	-------- year -----------
0E	/eosc	bbsqw	conv	-	-	intcn	A2IE	A1IE
11	sign------------------ temperature msb ------------------
12	-- t lsb --

}
pub !RTC
	--- set some defaults in case hardware is not present
	010101 4 SDT! 0 0 SDT! MON @day C!
	--- skip if no hardware RTC has been set
	@rtc 0EXIT
	--- otherwise buffer current RTC readings
	RDRTC
	--- read hours and convert to minutes
	2 rtcbuf@ $3F AND BCD>DEC 60 *
	--- read minutes, acc and convert to seconds
	1 rtcbuf@ BCD>DEC + 60 *
	--- read seconds and acc
	0 rtcbuf@ $7F AND BCD>DEC +
	--- convert to millisec and update soft rtc
	1000 * @time !				--- resynch soft rtc
	--- read year and decimal shift 4 places
	6 rtcbuf@ BCD>DEC #10000 *
	--- read month and decimal shift 2 places and acc
	5 rtcbuf@ $1F AND BCD>DEC 1 12 LIMIT #100 * +
	--- read date and acc
	4 rtcbuf@ $3F AND BCD>DEC 1 31 LIMIT DUP @day 1+ C! +
	--- latch date and set day
	@date !   3 rtcbuf@ 7 AND 1 MAX @day C!
	;


PRIVATE
word _job

pub TIMERJOB ( cfa -- )		BEGIN _job W@ 0= UNTIL _job W! ;

--- Provide background timing functions including alarm actions on timeouts
pri TIMERS
	--- reset timer chain and boot id
	1 timers W! 3 tid C+!
	--- clear variables
	runtime ~ _job ~
	--- set the WAITCNT DELTA for every millisecond
	ttint WAITX
	--- disable watchdog --- but link it into the timer list
 	wdt 16 ERASE 	0 wdt TIMEOUT
	--- set default watchdog behaviour
	' REBOOT wdt ALARM
	BEGIN
	  --- allow other cogs to get this cog to handle I/O inits etc
 	  _job W@ ?DUP IF _job W~ CALL THEN
	  --- runtime and time of day in milliseconds
 	  runtime ++    @time ++
	  --- maintain the linked chain of countdown timers
 	  CountDown
	  --- update soft RTC at start of day
	  @time @ 86,400,000 => IF !RTC THEN
	  --- make sure no alarm routine affects these lines (in this cog).
 	  $F000.0000 INPUTS
	  --- synch to next heartbeat
	  WAITCNT
	AGAIN
	;


--- EXTENDED KEY POLLING – UP TO 8 ENTRIES

pub ?POLL	NOP NOP NOP NOP NOP NOP NOP NOP ;

pub +POLL ( cfa -- )
	--- find a blank word                                  and set it
 	' ?POLL FROM 2 BY 8 FOR
	  DUP I W@ =
	    IF LEAVE ELSE I W@ ' NOP = IF DUP I W! LEAVE THEN THEN
	NEXT DROP
	--- ensure keypoll is set
 	' ?POLL keypoll W!
	;

{
8 words polls

pub ?POLL
	--- read 8 words and call if set
 	polls FROM 2 BY 8 FOR I W@ ?DUP IF CALL THEN NEXT
 	;
pub +POLL ( cfa -- )
	--- find a blank word                                  and set it
 	polls FROM 2 BY 8 FOR
	  DUP I W@ =
	    IF LEAVE ELSE I W@ 0= IF DUP I W! LEAVE THEN THEN
	NEXT DROP
	--- ensure keypoll is set
 	' ?POLL keypoll W!
	;
}
\ pub !POLLS	polls 16 ERASE keypoll W~ ;






--- Print counted string from EEPROM
pri .ES			SWAP FROM FOR I EC@ EMIT NEXT ;


(		*** Unified memory operators ***	)


{

--- Addresses $8000 upwards are EEPROM
pri EE?			DUP 15 >> ;
pub MC@++		DUP 1+ SWAP
pub MC@			EE? IF EC@ ELSE C@ THEN ;
pub MW@			EE? IF EW@ ELSE W@ THEN ;
pub MU@			EE? IF E@ ELSE U@ THEN ;
pub CPA			MC@++ >N + 1+ 1 ANDN ;
pub MLEN$		DUP BEGIN MC@++ 1 $7E WITHIN NOT UNTIL SWAP - 1- ;
}
{ PRINT$
msb set characters also add a space
$A0 character prints " -- " for stack comments
}
{
pub PRINT$		DUP MLEN$
pub CTYPE		SWAP FROM
	FOR I MC@
	  DUP $A0 = IF DROP PRINT"  -- "
	  ELSE
	  DUP $7F AND $09 MAX EMIT $80 AND IF SPACE THEN
	  THEN
	NEXT
	;

pub +NFA		EE? IF 16 + ELSE +NFA THEN ;							--- proceed to next name ;
}
--- common sub used by .EEMOD
pri ~MOD ( ptr -- )
	BEGIN
 	  DUP C@
 	WHILE
 	  DUP C@ 6 >> 3 =
 	    IF
	      --- print its CFA code address (old PFA)
 	      DUP CPA W@ .W:
	      --- display the module name and try to line up the description
 	      BOLD DUP .NFA DUP C@ >N 17 SWAP - SPACES
	      --- execute the module word to display it's message
 	      PLAIN DUP CFA CALL
	    THEN
	  +NFA
	REPEAT
	DROP
	;






(	*** INTERCOM ***	)

--- --- --- --- --- --- --- --- --- INTERCOM --- --- --- --- --- --- --- --- --- --- ---
{
$0030
$30	gpcfg         byte    0
$31	idcfg         byte    0
$32	trcfg         byte    0
$33	tecfg         byte    0
$34	ppbaud        long    sysfreq/2000000           ' default 2Mbps


INTERCOM ADDRESSES
$100		select none
$101..$1DF	select unit 1..223
$1E0..$1EE	select group 0..14
$1EF		select all
INTERCOM COMMANDS
$1F0
$1F1
$1F2
$1F3		INDUCT
$1F4
$1F5
$1F6
$1F7
$1F8		HUB memory
$1F9
$1FA		HALT cogs
$1FB		INIT cog
$1FC		BOOT image
$1FD
$1FE		RESET
$1FF		ETX marker


#222		default unassigned unit
}

--- &GP.ID.TR.TE   --- &01.12.14.15 INTERCOM!
pub INTERCOM! ( config baud -- )
	9600 2,000,000 LIMIT CLKFREQ SWAP / $34 E!
	$0F.FF.1F.1F AND $E0.00.00.00 OR $30 E!
	$30 $30 $10 ELOAD
	;



--- save unit prompt ID in place of " ok"
pub ID!	( str -- )		id $! id DUP 16 ESAVEB ;




(			*** POPULAR I/O DEVICES ***			)

--- PING MODULE ---
{ HC-SR04
10us high trigger pulse
660us later 8 cycles of 40kHz from transmitter

}
pub PING ( trig echo -- us )
	--- setup WAITPxx mask
	MASK 4 COG!
	--- 10us trigger (dummy cycles)
	DUP HIGH 10 us LOW
	--- detect high period
	WAITHI WAITLO
	--- calculate high period
	1 COG@ 2 COG@ - ABS
	--- convert cycles to us
	CLKMHZ U/
	;

--- return with the range in mm using trig pin and echo pin
pub DISTANCE ( trig echo -- distance.mm )	PING 170145 1M */  ;



--- DHT22 HUMIDITY AND TEMPERATURE ---

PRIVATE
word htck									--- checksum
word htref
long htsav
TIMER dt

\ --- Test for a DHT device on this line by pulsing low then checking for a hi-lo
\ pub DHT? ( pin -- flg )  DUP PIN@ OVER LOW 1 ms OVER FLOAT 80 us SWAP PIN@ NOT AND ;

{ HELP DHT ( pin -- rh temp )
Read the relative humidity and temperature from the DHT22 (and DHT11)
Return with rh and temp in Celsius
If an error occurred in the checksum then return last valid reading
If the sensor is polled more than once every 2 seconds then use last valid readings
Typical acquisition time ~5ms (inc 1ms reset)
start = 1 ms low
release ~ 20us
synch = 80us low 80us high
( 40-bits or 5 bytes of serial data )
0 = 50us low, 26us high
1 = 50us low, 70us high
WAITLO result in REG 1
WAITHI result in REG 2



}
pri DHTBIT ( -- cnt )		WAITHI 1 COG@ WAITLO 1 COG@ SWAP - ;

pri DHTBYTE ( -- byte )		0 8 FOR 2* DHTBIT htref W@ > >b OR NEXT DUP htck C+!	;

pub DHT ( pin -- rh temp )
---	mask for WAITHI/WAITLO
	MASK 4 COG! dt TIMEOUT?
 	IF
 	  2000 dt TIMEOUT htck C~
---	  Generate reset pulse (>18ms for DHT11) then float as input
	  4 COG@ L 1 ms F 5 FOR NEXT IN
---	proceed if pin went high again
	  IF
---	wait for start of response - use start bit as 2/3 reference timing
	  4 COG@ 20 BEGIN OVER IN WHILE 1- DUP 0= IF NIP 0 EXIT THEN REPEAT 2DROP
---	read synch 80us low, discard, measure 80 us high
	  WAITLO DHTBIT 3 / 2* htref W!
	  0 4 FOR 8<< DHTBYTE + NEXT ( hhtt )
	  --- latch reading if checksum good
	  htck C@ DHTBYTE = IF htsav ! 1 ELSE DROP 0 THEN htck 1+ C!
	  THEN
 	THEN
	--- return with latest valid result
	htsav 2+ W@ htsav W@
	;

( ..  15 .DHT 34.6'C  42.5%RH  ok )
pub .DHT ( pin -- )	DHT .AS" #~#.#'C  " .AS" #~#.#%RH " ;



--- WS2812 RGB LED SUPPORT

--- 170117 update - use LEDPIN to set LED pin parameter seperately
PRIVATE
long brg

pub RGBPIN ( pin# -- )				MASK L 5 COG! ;

{
byte intensity
pri modulate		brg 3 ADO I C@ intensity C@ * brg C! LOOP ;
}

PRIVATE

TABLE ansi	0 , $00.FF.00 , $00.00.FF , $00.FF.FF , $FF.00.00 , $FF.FF.00 , $FF.00.FF , $FF.FF.FF ,

pub ALED ( ansi )
	4* ansi + @
pub RGB ( rrggbb -- )
	--- check for 0..7 as ANSI VT100 color codes
\	DUP 8 <
\	IF 4* ansi + @ brg !
\	ELSE
	  DUP 16 >> brg 1+ C! DUP 8>> brg C! brg 2+ C!
\	THEN
	brg 1
--- Output an rgb array for the number of leds (3 bytes/led) on the selected pin
pub RGBS ( array leds -- )			3 * [WS2812] RUNMOD ;

{

\ ROUGH & READY RGB GARDEN LIGHTS
\ Testing one single WS2812 LED at present

long leds
pub FADEms	20 ms ;

--- fade the next channel and select next channel
pri FADE ( val var -- val>>8 var+1)
	OVER >B OVER C@ > IF DUP C++ THEN
	OVER >B OVER C@ < IF DUP C-- THEN
	1+ SWAP 8>> SWAP
	;

pub FADES ( rgb -- )
	$FFFFFF AND
	BEGIN
	--- repeat until value is reached
	  leds @ OVER <>
	WHILE
	--- incrementally adjust each chan if needed
	  DUP leds FADE FADE FADE 2DROP
	--- update and pause for effect
	  leds @ RGB  FADEms
	 REPEAT
	DROP
	;

pub FADER	16 RGBPIN 0 BEGIN DUP @ FADES 1+ AGAIN ;
20 ' FADEms C!
' FADER 7 RUN

}




{
\ PBASIC SHIFTOUT Dpin, Cpin, Mode, [OutputData {\Bits} {,OutputData {\Bits}...}]
pub SHIFTOUT ( data bits cpin dpin -- )	 ;

--- Shift out bytes from src buffer to SPI or shift registers
pub SHIFTOUTS ( src bytes -- )		SWAP FROM 0 SWAP FOR IC@ SPIWRB NEXT DROP SPICE ;

--- shift in up to 4 bytes into result
pub SHIFTIN ( dst bytes -- data ) 		0 SWAP FOR SPIRD NEXT SPICE ;
}








(	*** EVAL ***	)

{
byte tibwr
--- text input buffer is a variable constant
pub tib		$1C0 ;


pub EVAL$ ( str -- )	DUP FROM LEN$ FOR I C@ doKEY NEXT $20 doKEY $0D doKEY ;


pri EKEY
	DUP $08 = IF DROP tibwr C@ IF 8 EMIT SPACE 8 EMIT tibwr C-- THEN EXIT THEN
	DUP $0D = IF DROP tibwr C@ IF tib EVAL$ tibwr C~ THEN PRINT"  ok" CR EXIT THEN
	DUP EMIT tibwr C@ tib + C! tibwr C++ tibwr C@ tib + C~
	;

pre OK
	ON QUIET CR tibwr C~ tib C~
	BEGIN KEY ?DUP IF KEY THEN AGAIN
	;
}
















word pwmtbl
word pwmfreq
long pwmpins

\ set the PWM duty cycle as a percentage
pub PWM% ( %duty -- dutyval )		8<< 100 / ;


{ PWM32 - max freq is 7.6kHz
 Task that runs the PWM engine in a COG
}
\ long pwmmask								--- output mask
pri PWM.TASK
	pwmpins @ OUTCLR							--- set outputs & dir in PWM cog
	[PWM32]								--- load PWM32 runtime module
	pwmtbl W@ pwmfreq W@ RUNMOD					--- and run it
	;

--- Main multichannel PWM start method in next available cog
pub PWM.START ( mask table hz --  )
	CLKFREQ SWAP / 8>> pwmfreq W!
	DUP $400 ERASE
	pwmtbl W!							--- pass the table address
	pwmpins !							--- pass the I/O mask
	' PWM.TASK TASK? RUN
	;

\ pub PULSEWIDTH ( duty pin -- )
pub PWM ( duty8 pin -- )
 	MASK
pub PWM! ( duty8 mask -- )
	pwmtbl W@ [PWM32!] RUNMOD
	;
{
\ pub PULSEWIDTHS ( duty firstpin lastpin -- )
pub SETPWMS ( duty8 firstpin lastpin -- )
 	1+ OVER - MASKS PWM!
 	;
}
{
pub SETPWMW ( on on+off pin -- )
 	\ to be implemented
 	;


( TESTING )
256 longs pwms
$FFFF pwms 7600 PWM.START

}

\ ALIAS SETPWM PULSEWIDTH
\ ALIAS SETPWMS PULSEWIDTHS













(	*** ROMS ***		)

$E000		:= roms
$1F00		:= romsz
" .ROM" U@	:= .rom







pri NEXTROM ( addr -- addr2 | false )
	BEGIN DUP E@ .rom <> WHILE CELL+ DUP roms romsz + => IF DROP FALSE EXIT THEN REPEAT
	NOP
	;

pri FINDROM ( name -- nameaddr | false )
	roms
	BEGIN NEXTROM DUP ( name @rom flg )
	WHILE 6 + OVER U@ OVER E@ = IF OVER CELL+ U@ OVER CELL+ E@ = IF NIP EXIT THEN THEN
	--- skip over this rom
	DUP 2- EW@ + 2+
	REPEAT
	NIP
	;

{		--- COGINIT ( code pars cog -- ret )
@VGA $200 + vgapars 2 LOADCOG
0 = Tachyon console
1 = serial recevie
2 = TIMER
}

--- usage: " HSUART    " 3 par1 12 5 LOADCOGS
pub LOADCOG ( name cog par  -- )
	0 1
pub LOADCOGS ( name cog par step cogs -- )
	SWAP >R SWAP >R ( name cog cogs )
	ROT FINDROM ?DUP ( cog cogs eeadr )
	IF
	  DUP 8 .ES SPACE
	  ( cog cogs eeadr )
	   ( eadr+10 [eadr-2])
	  DUP 10 + SWAP 2- EW@ ( cog cogs eeadr ebytes )
	  OVER .W DUP .W
	  ep ALIGN $8000 OVER - ( cog cogs eeadr ebytes buffer )
	  -ROT 3RD SWAP ELOAD
	  R> FROM R> BY -ROT FOR ( buffer cog )
---	 COGINIT  ( code pars cog -- ret )
  ( buf cog buf par cog )
	    OVER I 3RD CR 3RD .W I .W DUP .           COGINIT DROP
	    1+
	  NEXT
	ELSE
	  R> R> 2DROP
	THEN
	2DROP
	;


(	*** F32 FLOATING POINT SUPPORT ***	)

PRIVATE
long f32cmd	( f32 parameter block - force alignment using longs )
long result long fnumA long fnumB


pub FCMD ( n1 n2 cmd -- result )  result ! fnumB ! fnumA ! result f32cmd ! BEGIN f32cmd @ 0= UNTIL result @ ;

pub >F ( n1  -- result )	0 $5CFC8E42 FCMD ;
pub F> ( n1 -- result )		1 $5CFCBE48 FCMD ;
pub F+ ( n1 n2 -- result )	$5CFC3C0D FCMD ;
pub F- ( n1 n2 -- result )	$5CFC3C0C FCMD ;
pub F* ( n1 n2 -- result )	$5CFC641F FCMD ;
pub F/ ( n1 n2 -- result )	$5CFC6233 FCMD ;
pub FSIN ( n1 -- result )	0 $5CFD72A2 FCMD ;
pub FSQRT ( n1 -- result )	0 $5CFD006C FCMD ;












(	*** DEFER SUPPORT ***	)

pri ,WORD$
	--- compile code for inline string
	' (") [C] [W]
	--- process word as string
	@WORD DUP FROM LEN$ 1+
	--- and compile it including terminator
	  FOR I C@ [C] [B] NEXT
	--- clear out word
	@WORD 1- 32 ERASE
	--- skip returning to error handler
	R> DROP
	;


pri ?DEFER
---	execute up to 4 defer vectors
	NOP NOP NOP NOP
---	then reset them all
	' NOP ' '?DEFER W! ' ?DEFER DUP 2+ 6 CMOVE
	undef W~
	;

pub DEFER
	--- cause undefined words to be handled
	' ,WORD$ undef W!
	--- and defered code to execute on acceptance of line
	' ?DEFER prompt 2+ W!
	R>
	--- push onto defer stack
	' ?DEFER 2+ ' ?DEFER 6 CMOVE
	--- last entry is last to execute
	' ?DEFER 6 + W!
	;



pub BOOT
	vars $8000 OVER - ERASE
	keypoll W~
	' TIMERS 2 RUN
\	!POLLS
\	CR green PEN f32cmd 3 " F32     " LOADCOG  PLAIN ( start up F32 )
	--- clear out buffers as LOADCOG just used this
	--- generate a seed
	seed =CNT RND seed !
	--- abort inits if ^A is detected
	BEGIN KEY ?DUP WHILE 1 = IF  CR PRINT"  <aborting startup> " DISCARD EXIT THEN 20 ms REPEAT
	?ANSI
	" ??" NFA$ ?DUP IF CFA CALL ELSE .STATS THEN
	INIT
	;








IFDEF +VGA
module VGATEXT    PRINT" VGA text driver (minimal) 180218-0000" ;

BUFFERS	:= vgabuf

byte color
byte row
			--- current palette color, row and column
long col		--- use long for column position to allow signed value for offset

TABLE colors
$F000.F000 ,     $F0F0.0000 ,     $2000.2000 ,     $2020.0000 ,
$C000.C000 ,     $C0C0.0000 ,     $0800.0800 ,     $0808.0000 ,
$8800.8800 ,     $8888.0000 ,     $2800.2800 ,     $2828.0000 ,
$C0FC.C0FC ,     $C0C0.FCFC ,     $FC00.FC00 ,     $FCFC.0000 ,

TABLE vgapars PRIVATE
    0 ,                --- 0:status              ' 0/1/2 = off/visible/invisible - read-only
    1 ,                --- 1:enable              ' 0=off (disabled completely)
    16 7 + ,           --- 2:pins                ' vga pin group 0,8, or 16.
    %1000 ,            --- 3:mode                ' %tihv = tile,interlace,hpol,vpol   write-only
    vgabuf , colors ,  --- 4:screen 5:colors     ' pointers to screen (words) and colors (longs)
    32 , 15 ,          --- 6:cols 7:rows         ' horz and vert tiles (characters)
    1 , 1 ,            --- 8:hx 9:vx             ' horz and vert tile expansion
    0 , 0 ,            --- 10:ho 11:vo           ' horz and vert offset
    512 , 10 ,         --- 12:hd 13:hf           ' horz display ticks, front porch
    75 , 43 ,          --- 14:hs 15:hb           ' horz synch ticks, back porch
    480 , 11 ,         --- 16:vd 17:vf           ' vert display lines, front porch
    2 , 31 ,           --- 18:vs 19:vb           ' vert synch lines, back porch
    CLKFREQ 2 >> ,     --- 20:rate		         ' tick rate (Hz)

--- address a vga parameter
pub @VP ( reg -- addr )		2* 2* vgapars +  ;
pub VGAPIN ( pin -- )		7 + 2 @VP ! ;
pub screen			4 @VP @ ;
pub cols			6 @VP @ ;
pub rows			7 @VP @ ;

--- select the current drawing/font color
pub HUE ( color -- )	7 AND color C! ;

byte vflg     --- 0:esc 7:nowrap

pri VCLS		$220
pri VFILL ( word -- )   screen W! screen DUP 2+ rows cols * 1- 2* CMOVE
pri VHOME		0 0
pub VXY    ( x y -- )	row C! col ! ;

pri scroll
    screen DUP cols 2* + SWAP rows 1- cols 2* * CMOVE
    rows 1- cols 2* * screen + FROM 2 BY cols FOR $220 I W! NEXT
    ;

pri NEWLINE
    col ~
    row C++
    row C@ rows => IF scroll row C-- THEN
    ;

14    := bigch
--- Plot or unplot a point (tile) at current XY
pub PLOT        IF bigch ELSE $20 THEN
--- Display the VGA character and update position etc
pub VCHAR ( ch -- )
     >B
     --- new line if needed (scrolls up if needed)
     col @ cols => IF $80 vflg SET? IF DROP EXIT ELSE NEWLINE THEN THEN
     --- (color << 1 + c & 1 )
     DUP >b color C@ 2* +
     --- form color field
     10 << $200 +
     --- merge 7 msb of data
     SWAP 1 ANDN +
     --- write to the current screen position
     row C@ cols * col @ +
      2* screen + W!
     col ++                       --- increment column position
     ;

--- spaces until the next tab slot
pri VTAB    BEGIN 32 VCHAR col @ 7 AND 0= UNTIL ;

pub VGA ( ch -- )
    EMIT:
    DUP 32 < 1 vflg SET? 0= AND
    IF
    SWITCH
      $1B CASE 1 vflg SET BREAK                    --- ESC will accept next byte as data
      $01 CASE VHOME BREAK
      $09 CASE VTAB BREAK
      $08 CASE col @ IF col -- THEN BREAK
      $0D CASE col ~ BREAK
      $0A CASE NEWLINE BREAK
      $0C CASE VCLS BREAK
      $10 $17 CASES SWITCH@ HUE BREAK        --- codes $10..$17 select a color
     $18 CASE $80 vflg CLR BREAK                --- wrap
     $19 CASE $80 vflg SET BREAK                --- no word wrap
    1 vflg CLR SWITCH@
    THEN
    VCHAR
    ;


@org W@ := evga

--- Init the VGA interface if it hasn't been done yet
pub !VGA
    color evga OVER - ERASE
    " VGA32x15  " 3 vgapars LOADCOG
    VCLS
    ;



IFDEF +KEY
(	*** KEYPAD *** 	)

{
	56 KEY ARBITRARY MATRIX KEYPAD SCANNER

Any combination of column and row pins can be used,
just specify the bit masks for rows and columns.
The scanner will only enable and read port pins
that are active. Up to 256 key matrix is possible.
The key is encoded as 5-bit row + 5-bit column
corresponding to the port pins.
These can then be decoded.
}

module ANYKEYS     PRINT" ANYKEY KEYPAD 171005" ;

PRIVATE

16 bytes kpbuf	--- keypad buffer
long rowm	--- row mask
long colm	--- column mask
word kprw	--- read/write index
word _key	--- key code
word kptbl	--- ptr to scancode table

TIMER kptmr
TIMER beeptmr


pri *beep       32 ;

pub BEEPER      ' *beep C! ;

{
Test the keypad for a keypress and if so then scan and return with a valid ASCII code
The key has to be released or another detected
If there is no key or the key is still pressed than it returns with a null (zero).
To prevent the keypad from interfering with the LCD just use some ~220R to 1K series resistors in the rows
Execution time if no key is pressed: 37us or 268us on key press (must be <1ms for timer call)
}

--- replace contents with cfa of user beep

pub KEYBEEP     NOP *beep 32 < IF *beep APIN 1 KHZ 20 beeptmr TIMEOUT THEN ;

pub KEYMUTE     NOP *beep 32 < IF MUTE *beep FLOAT THEN ;


pri ROW@	rowm @ DUP DUP INPUTS P@ AND XOR ;



pri DECODEK ( scancode -- char )
	kptbl W@ ?DUP 0EXIT
	BEGIN DUP W@
	WHILE
	  DUP W@ 3RD = IF 2+ C@ NIP EXIT THEN
	CELL+
	REPEAT
	DROP
	;


pri (KEYPAD) ( --- key )
--- enable all columns --- read the rows
	FALSE colm @ OUTCLR ROW@ \ rowm @ <>
--- a key is pressed, but which one?
	IF
--- scan all active columns - default false result
	  28
	  FOR
--- scan for the next active column according to column mask
	    colm @ DUP INPUTS I MASK AND
	    IF --- pull a column down low and delay for discharge
             I LOW 20 us ROW@ ?DUP --- found the column
              IF >| 5 << I OR NIP ( rowcol ) LEAVE THEN
            THEN
          NEXT
        ( rowcol | false )
        DUP
        IF ( keycode )
          DUP _key W@ =
	  IF 0= ( change value to a false flag )
--- update keypad variable with latest key
	  ELSE DUP _key W! KEYBEEP
	  THEN
   	ELSE  _key W~
      	THEN
      	ELSE  _key W~
      	THEN
	;

pri ?KEYPAD
---	get key  if valid then buffer               update write
	(KEYPAD) ?DUP IF DECODEK kpbuf kprw 1+ C@ >N + W!  2 kprw 1+ C+! THEN
--- timeout until next scan (10ms)
	10 kptmr TIMEOUT
	;



--- Startup background timer scan for keypad
--- Don't use a table if tbl=0
pub !KEYPAD ( tbl rowmask colmask )
	colm ! rowm ! kptbl W!
	kprw W~
	' ?KEYPAD kptmr ALARM
  	' KEYMUTE beeptmr ALARM
--- kick off the timer
	1 kptmr TIMEOUT
	;


pub KEYPAD@ ( -- key )
	kprw 1+ C@ >N kprw C@ >N <>
	IF kprw C@ >N kpbuf + W@ 2 kprw C+!
	ELSE FALSE
	THEN
	;

--- set the console input device to the keypad
pub KEYPAD    ' KEYPAD@ ukey W! ;

}



IFDEF +LCD
(	CHARACTER LCD 	)

{
Version E looks at having the LCD itself accessed from timer interrupts every 2ms
writing one character at a time from the FIFO buffer to the current
LCDEMIT routine except there are no extra delays due to the 2ms update period
}



module CHARLCD     PRINT" BUFFERED CHARACTER LCD " ;

pri *lcd        32 ;
pri *rs         32 ;
pri *e          32 ;
pri *bl         32 ;

pri #chars      20 ;
pri #lines      4 ;

long lcdpins    --- data bus mask
byte xpos       --- x position
byte ypos       --- y position
byte lcdlm      --- left margin
byte lcddm      --- display mode

( programmble constants )

--- Output a byte to the LCD as a character
pri LCDDAT ( ch --  )
    *rs HIGH
pri ~W ( data  -- )
	>B
--- Prep data bus as outputs and write data
	lcdpins @ OUTCLR  *lcd << OUTSET
--- 2us pulse chip enable then release data
	*e HIGH *e LOW lcdpins @ INPUTS
	;
--- Output a byte to the LCD as an instruction
pri LCDCMD ( cmd -- )       *rs LOW ~W ;

pri LCDCLS                  1
pri LCDCMD1		    xpos W~ LCDCMD ;
pri LCDHOME                 2 LCDCMD1 ;
pri LCDON                   4 lcddm SET
 pri LCDDM                  lcddm C@ LCDCMD ;
pri LCDOFF                  4
pri ~M                      lcddm CLR LCDDM ;
pri LCDHIDE                 3 ~M ;


pri XLTCUR ( abs -- xlt )
    DUP 20 < ?EXIT
    DUP 59 > IF 24 + EXIT THEN
    DUP 39 > IF 20 - EXIT THEN
    44 +
    ;

pri LCDCR                   lcdlm C@ xpos C!
--- update the LCD's internal cursor pointer
pri XYCUR ( -- <cur> )      ypos C@ #lines 1- AND #chars * xpos C@ +
pri SETCUR ( c -- )         >B 79 MIN XLTCUR $80 OR LCDCMD ;

pri LCDLF                   ypos C++ XYCUR ;

pri LCDCHAR ( ch -- )
    LCDDAT xpos C++ xpos C@ #chars =>
      IF LCDCR LCDLF THEN
    ;


pri LCDTAB                  BEGIN $20 LCDCHAR xpos C@ 7 AND 0= UNTIL ;
pri LCDBS                   xpos C@ IF xpos C-- THEN XYCUR ;

pri blpwm                   0 7 AND ;
pub LCDBL ( on/off -- )     ' blpwm C! ;

--- simulate a simple PWM for the backlight using the timers
TIMER bltmr
pri BLPWM
    blpwm ?DUP
    IF
      7 = IF *bl HIGH 1 ELSE
      *bl PIN@ IF *bl LOW 7 blpwm - ELSE *bl HIGH blpwm THEN
      THEN
    ELSE
      *bl LOW 1
    THEN
    bltmr TIMEOUT
    ;


--- Setup pins and init LCD ( 0 selects last pins set )
pri ZLCD
    *lcd 8 + MASK 1- lcdpins !
    *e LOW *rs LOW
    *bl 32 <
    IF
    --- if enabled then dim backlight and start PWM
      7 LCDBL
      ' BLPWM bltmr ALARM
      1 bltmr TIMEOUT
    THEN
    $0C lcddm C!
    xpos W~   lcdlm C~
    --- 8-bit init seq as a string
\    " XX`,&!"!" FROM 8 FOR I C@ $20 - LCDCMD 2 ms NEXT
    ;


pri (LCDEMIT)
	DUP $20 <
	IF
 	  SWITCHES
 	  $01 LCDHOME
 	  $0D LCDCR     $0A LCDLF   $0C LCDCLS
 \     $0E LCDBL     $0F LCDNBL
 	  $08 LCDBS     $09 LCDTAB  $15 LCDON
	  $16 LCDOFF    $04 LCDHIDE	$1A ZLCD
	  SWITCH@
	THEN
--- use 16-bit commands
	DUP 8>> SWITCHES
	$00 LCDCHAR $01 SETCUR $02 LCDBL
	$03 LCDCMD
	DROP
	;


TIMER lcdtmr

64 1-	:= lcdsz

byte lcdrd

byte lcdwr

lcdsz 1+ bytes lcdbuf

pri WRLCD
	lcdrd C@ lcdwr C@ <>
	IF
	  lcdrd C@ lcdsz AND lcdbuf + C@
	  DUP lcdsz > IF lcdsz AND LCDCMD ELSE (LCDEMIT) THEN
	  lcdrd C++
	  2 lcdtmr TIMEOUT
	THEN
	;

pub LCD
	2 lcdtmr TIMEOUT ' WRLCD lcdtmr ALARM
	EMIT:
	BEGIN lcdrd C@ lcdsz AND lcdwr C@ 1+ lcdsz AND <> UNTIL  lcdwr C@ lcdsz AND lcdbuf + C! lcdwr C++ 2 lcdtmr TIMEOUT
	;

\ pub LCD   	' LCDEMIT uemit W!  ;

pub !LCD ( &ch.ln &bl.ce.rs.dat --- )
    ?DUP IF
      DUP >B ' *lcd C!
      8>> DUP >B ' *rs C!
      8>> DUP >B ' *e C!
      8>> ' *bl C!
      DUP ' #lines C!
      8>> ' #chars C!
    THEN
    ZLCD
    lcdrd W~
    LCD
    $B8 EMIT $B8 EMIT
    $C0 EMIT $8C EMIT
    $86 EMIT
    CLS 1 EMIT CON
;
}

{
16 LOW 14 LOW
&20.4 &18.17.15.0 !LCD
LCD PRINT" Hello World!" CON
}








( The TOOLS module may be safely forgotten through FORGET if not needed )

module TOOLS	PRINT" DEV TOOLS " ;




--- read pin load as floating, up, or down
pri ~p	I FLOAT 10 us I PIN@ >b 10 us ;

pub lsio
	DIRA COG@
	31 FROM -1 BY 32
	FOR
	  I 3 AND 3 = IF SPACE I . ':' EMIT THEN
	  I MASK OVER AND
	  IF
	    I PIN@ IF 'H' ELSE 'L' THEN EMIT
	  ELSE
	    I LOW ~p 2* I HIGH ~p + " D~?U" + C@ EMIT
	  THEN
	NEXT
	DIRA COG!
	KEY DROP
	;
\ " I2C000I2C001I2C002I2C003I/O   DPY IOEEPROMI2C00BI2C00CRTC   I2C00EI2C00F"
pri ~I
	4 >> SWITCH
	$04 CASE " I/O"		BREAK
	$07 CASE " DPY IO"	BREAK
	$0A CASE " EEPROM"	BREAK
	---            and automatically add the device if it is found
	$0D CASE " RTC" @rtc NOT IF I =rtc THEN BREAK
	" unknown"
	;

pub lsi2c
	" I2C" .HEAD$ yellow PEN
	2 BY 128 FOR
	  <I2C I 1+ I2C!? 0=
	    IF CR I '$' EMIT .BYTE SPACE I ~I PRINT$ THEN
	  I2C>
	NEXT
	PLAIN
	;

byte ncol
pub NEON    EMIT: [CON ncol C@ 3 AND " 6325" + C@ PEN EMIT ncol C++ CON]  ;

pub .MODULES
	CR 2 SPACES " MODULES" .HEAD$
	( CR 20 XTAB ) NEON .VER CON PLAIN
	@NAMES ~MOD CR
	\ $8000 ~MOD
	;



--- INTERCOM: &01.12.14.15 @1,000,000 ok
pub .INTERCOM
	BOLD PRINT" INTERCOM: " PLAIN
	$30 @ 0EXIT
	$33 C@ '&' EMIT >N .DEC2.
	$32 C@ .DEC2.
	$31 C@ .DEC2.
	$30 C@ .DEC2
	'@' EMIT CLKFREQ $34 @ / .AS" ###,###,~###"
	;

pub .AUTO	 PRINT" AUTORUN " uauto W@ ?DUP IF .CFA ELSE PRINT" <OFF>" THEN ;

--- FREQ = 96MHz
pub .FREQ	CR PRINT" FREQ = "
pub ~F		CLKFREQ 10,000 /  .AS" *|#.##MHZ" ; ( allow >99.99MHz to report )

(	*** TIMING REPORTS ***		)


pub .LAP
	LAP@ DUP .AS" ###,###,##~# cycles = "
	DUP CLKFREQ 1- U>
	--- seconds
	  IF 1,000 CLKFREQ UM*/ <D> .AS" *|#.###sec " EXIT THEN
	CLKFREQ 1,000 U/ ( clkkhz 96000 )
	1M SWAP UM*/ DROP
	DUP 999,999 U> OVER 31 >> OR
	  IF 1,000 U/ .AS" *|#.###ms "  EXIT THEN
	.AS" *|#.###us "
	;


pub lsroms
	" ROMS" U@ roms E@ =
	IF " ROMS" .HEAD$ cyan PEN
	  .rom roms
	BEGIN DUP E@ 3RD =
	  IF ( ROMS PTR )
	   DUP 16 + .W: DUP 6 + 10 .ES SPACE DUP CELL+ EW@ .AS" ###`#"
	   DUP CELL+ EW@ +
	  ELSE
	   CELL+
	  THEN
	DUP roms romsz + =>
	UNTIL
	2DROP
	ELSE DROP PRINT" NO ROMS"
	THEN
	PLAIN
	;



pub lsini
	CR " INITS" .HEAD$
	red PEN
	' INIT
	BEGIN
	  DUP W@ ' EXIT <>
	WHILE
	  DUP W@ ' NOP <>
	    IF DUP W@ CR .CFA THEN
	  2+
	REPEAT
	DROP PLAIN
	;

pub ??
	.MODULES CR .AUTO .FREQ
	lsini
	CR lsroms
	CR I2C100 lsi2c I2C400 !RTC
	CR BOLD PRINT" I/O = " PLAIN red PEN lsio PLAIN
	CR .INTERCOM CR .STATS
	.DT
	;

pri ~V ( nfa -- )
	0 SWAP
	BEGIN ( wcnt nfa )
	  DUP C@ ( wcnt nfa atr+cnt )
	WHILE
	  DUP
	  CFA ( wcnt nfa cfa )
	  DUP 15 >> IF
---	    newline or tab horizontal
	    3RD 6 MOD 0= IF CR ELSE 3RD 6 MOD 20 * XTAB THEN
---	    vary color based on 2 lsb of value
	    $7FFF AND DUP 3 AND " 2365" + C@ PEN .W DUP .NFA
	    SWAP 1+ SWAP
	  ELSE DROP
	  THEN
	  +NFA
	REPEAT
	2DROP PLAIN
	;

pub .VARS	@NAMES ~V ; \ $8000 ~V ;



{
...  NFA' FLOAD 10 DUMP
0000.5748:   85 46 4C 4F  41 44 9C 4C  85 46 43 4F  50 59 54 4C    .FLOAD.L.FCOPYTL
...  NFA' FOPEN$ 10 DUMP
0000.57C6:  06 46  4F 50 45 4E  24 00 7C 4A  82 6D 6B 00  78 4A    .FOPEN$.|J.mk.xJ
...  NFA' ~W 10 DUMP
0000.0000:   00 B4 C4 04  6E E8 10 00  40 7E 48 7E  20 7E 4C 7E    ....n...@~H~ ~L~
...  NFA' APPEND.BLK 10 DUMP
0000.578A:  4A 41  50 50 45 4E  44 2E 42 4C  4B 00 46 4B  07 2D    JAPPEND.BLK.FK.-
...  NFA' EASYFILE 10 DUMP
0000.5D96:  C8 45  41 53 59 46  49 4C 45 00  EE 3F 04 42  4F 4F    .EASYFILE..?.BOO
}
pri lsword ( nfa -- nfa )
	DUP C@
	--- print attribute
	PLAIN 6 >> DUP
	2 AND IF BOLD THEN
	>b IF red ELSE green THEN
	OVER CFA 15 >> IF 3 * THEN
	PEN
	\  $20 AND IF BOLD ELSE PLAIN THEN 8 AND IF red ELSE green THEN PEN
	DUP .W DUP CPA W@ .W
	DUP C@ 5 >> PRINT SPACE
	DUP .NFA
	;

pre WWORDS
	lastkey C@ $0D <> IF WKEY ELSE 0 THEN
	@NAMES
--- common sub for WWORDS
\ pri ~W
	CR PRINT" NFA  CFA  V NAME"
	0 SWAP
	BEGIN
	  PLAIN DUP C@
	  KEY $1B <> AND
	WHILE ( match wcnt nfa )
	  3RD OVER 1+ C@ =
	  4TH 0= OR
	  IF
	  OVER 3 AND 0= IF CR THEN
	  SWAP 1+ SWAP
	  lsword
	  16 OVER C@ $1F AND - SPACES
	  \ DUP MC@++ $1F AND SWAP OVER CTYPE 16 SWAP - SPACES
	  THEN
	  +NFA
	REPEAT
	3DROP CR
	;

\ pub WWORDS	@NAMES ~W ; \ $8000 E@ -1 <> IF $8000 ~W THEN ;

{ $7C00 wordcodes
_ROR    = $41+pc
_ROL    = $49+pc
_SHR    = $51+pc
_SHL    = $59+pc
_SAR    = $71+pc
_REV    = $79+pc
_MAXS   = $81+pc
_MINS   = $89+pc
_MAX    = $91+pc
_MIN    = $99+pc   ' Forth MIN takes the minimum value vs PASM
_AND    = $C1+pc
_ANDN   = $C9+pc
_OR     = $D1+pc
_XOR    = $D9+pc
_ADD    = $101+pc
_SUB    = $109+pc
_CMPSUB = $1C1+pc
_ADDABS = $111+pc
_SUBABS = $119+pc
_ADDS   = $1A1+pc
_SUBS   = $1A9+pc

NIP     = $141+pc ' mov tos+1,tos DROP

_WAITVID = $1F8+pc
}
{
pre DECOMP ( <name> )
	lastkey C@ $0D <> IF [C] ' GRAB ?DUP 0EXIT THEN
}
pre HELP
	GRAB [C] NFA' ?DUP 0= IF DEPTH 0EXIT
	ELSE DUP lsword CFA THEN
	CR
\ pri (DECOMP)
	0 KEY!
	BEGIN PLAIN DUP .W:
	  DUP W@ DUP 15 >>
	  IF
   	    $7FFF AND cyan PEN DUP 16 < IF PRINT ELSE ." $" .WORD THEN
	  ELSE
	    DUP DUP $1F0 > IF 1 ANDN THEN
	    DUP IF NFA ?DUP THEN
	    IF .NFA ' EXIT = IF CR 700 ms THEN
	    ELSE
	      DUP $7F00 >
	      IF
	        DUP $7F AND 2* SWAP $80 AND IF NEGATE THEN
	        DUP 0< IF PRINT" UNTIL "  ELSE PRINT" IF " THEN
		OVER 2+ + .WORD
	      ELSE
	        red PEN 2DUP - ABS 1 128 WITHIN
		  IF DUP 1 AND IF PRINT" GOTO " ELSE PRINT" CALL " THEN 1 ANDN THEN
		.WORD
	      THEN
	    THEN
	  THEN
	  2+ KEY $0D =
	UNTIL
	CR PLAIN DROP
	;


{
pub MAP ( blksize -- )
 	HEX $10 MAX $1000 MIN BY
	0 $8000 FOR
	OVER $3F AND 0= IF CR I .ADDR SPACE THEN
	SWAP 1+ SWAP  0 I 3RD ADO I @ OR 4 +LOOP
	IF  I OVER U/ >N . ELSE ." ." THEN
	 DUP +LOOP 2DROP
	 ;
}



pub .INDEX 	CR I .AS" ##: "  ;

pub .TASKS ( -- )
	8 FOR
	  I TASK 2+ C@ DUP
	  IF   .INDEX I TASK W@ ?DUP
	    IF DUP .CFA NFA
	    ELSE PRINT" IDLE"
	    THEN
	    20 XTAB
	  THEN
	  I COGID = DUP
	    IF   .INDEX PRINT" CONSOLE" 20 XTAB THEN
	  OR IF I TASK DUP W@ .W 2+ FROM 6 FOR I C@ .BYTE SPACE NEXT THEN
	NEXT
	;


pub .TIMERS
      SPACE CLKFREQ ttint /   .AS" ticks = 1/~#,#~##"
      runtime @ .AS"  runtime = ~#,#~##"
        --- read links
 	timers W@
 	BEGIN
 	  DUP $FF >
 	WHILE
 	  DUP .W:
 	  DUP $8000 + .CFA 20 XTAB
 	  DUP @ .AS" ###,##~#ms ="
 	  DUP @ .LONG
 	  ."  L" DUP 6 + W@ .W
	  DUP 4 + W@ IF ." ALARM=" DUP 4 + W@ .CFA THEN
 	  6 + W@ --- fetch the link to the next timer
 	REPEAT
 	DROP
 	;

0 bytes y

@NAMES 8 - := z

pri u
pub DEFAULTS
	y org
	' u 22 + uhere W!
	z names W!
	!INITS
	;
RECLAIM y



' WWORDS ^w SHORTCUT
' ?? ^P SHORTCUT
' .VARS ^V SHORTCUT










--- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---

IFNDEF ~K
--- Scan first 32k of EEPROM for any ROMs and move them up into the special ROM area, then forget this routine
pub SAVEROMS
	ep 64 > 0EXIT
\	" ROMS" U@ roms E@ <> 0EXIT
\	roms $1F00 $FF EFILL
	--- search for ROMS string between end of kernel at TACHYON and start of dictionary
	" ROMS" U@
	' TACHYON 2000 + 3 ANDN FROM ( src )
	@NAMES 3 ANDN OVER - 2/ 2/ 4 BY ( src lcnt )
	FOR I E@ OVER =				--- found a match for "ROMS"
	  IF I 8 + E@ OVER =			--- Yes but verify for additional ROMS sig
	    IF
	      CR 20 SPACES PRINT" COPY ROMS from $" I .WORD
	      PRINT"  for " I CELL+ E@ DUP .DEC4 SPACE CR
	--- Copy ROMs from old EEPROM location to upper EEPROM
	      I roms ROT romsz MIN ECOPY
	--- erase original ROMs
\	      I 8 4 DOFOR 0 I E! LOOP
	      LEAVE
	    THEN
	  THEN
	NEXT
	DROP
	;



errors W@ 0= IF SAVEROMS THEN
--- wipe ROMS pattern from U@ register
0 U@ DROP
FORGET SAVEROMS


errors W@ 0= IF AUTORUN BOOT THEN
I2C400

$7510 @org W@ OVER - ERASE
" UTC " TZ
END


?BACKUP
REBOOT

( V.47 reports FREE:      = 5836 bytes )
